/**
 * Precision constants
 */
export declare const FLOAT_COMPRESSION_PRECISION = 1000;
export declare const DATE_LOW_PRECISION = 100000;
/**
 * Floating point delimiters
 */
export declare const FLOAT_FULL_PRECISION_DELIMITER = ",";
export declare const FLOAT_REDUCED_PRECISION_DELIMITER = ".";
/**
 * Data type tokens
 */
export declare const INTEGER_TOKEN = "¢";
export declare const FLOAT_TOKEN = "£";
export declare const STRING_TOKEN = "¨";
export declare const DATE_TOKEN = "ø";
export declare const LP_DATE_TOKEN = "±";
export declare const UNREFERENCED_INTEGER_TOKEN = "¤";
export declare const UNREFERENCED_FLOAT_TOKEN = "¥";
export declare const UNREFERENCED_STRING_TOKEN = "´";
export declare const UNREFERENCED_DATE_TOKEN = "¿";
export declare const UNREFERENCED_LP_DATE_TOKEN = "ÿ";
export declare const REF_INTEGER_TOKEN = "º";
export declare const REF_FLOAT_TOKEN = "Ý";
export declare const REF_STRING_TOKEN = "ß";
export declare const REF_DATE_TOKEN = "×";
export declare const REF_LP_DATE_TOKEN = "ü";
export declare const NULL_TOKEN = "§";
export declare const UNDEFINED_TOKEN = "µ";
export declare const BOOLEAN_TRUE_TOKEN = "»";
export declare const BOOLEAN_FALSE_TOKEN = "«";
/**
 * String escape tokens
 */
export declare const ESCAPE_CHARACTER = "\\";
export declare const ESCAPED_STRING_TOKEN: string;
export declare const ESCAPED_UNREFERENCED_STRING_TOKEN: string;
/**
 * Regex lookups
 */
export declare const REGEX_STRING_TOKEN: RegExp;
export declare const REGEX_ESCAPED_STRING_TOKEN: RegExp;
export declare const REGEX_UNREFERENCED_STRING_TOKEN: RegExp;
export declare const REGEX_UNREFERENCED_ESCAPED_STRING_TOKEN: RegExp;
export declare const DATE_REGEX: RegExp;
/**
 * Structural tokens
 */
export declare const OBJECT_START_TOKEN = "{";
export declare const OBJECT_END_TOKEN = "}";
export declare const TEMPLATE_OBJECT_START = "¦";
export declare const TEMPLATE_OBJECT_END = "‡";
export declare const TEMPLATE_OBJECT_FINAL = "—";
export declare const ARRAY_START_TOKEN = "|";
export declare const ARRAY_END_TOKEN = "÷";
export declare const ARRAY_REPEAT_TOKEN = "þ";
export declare const ARRAY_REPEAT_MANY_TOKEN = "^";
export declare const ARRAY_REPEAT_COUNT_THRESHOLD = 4;
/**
 * General tokenization constants
 */
export declare const REFERENCE_HEADER_LENGTH = 1;
export declare const DELIMITING_TOKENS_THRESHOLD = 122;
/**
 * Small integer tokens
 */
export declare const INTEGER_SMALL_EXCLUSIVE_BOUND_LOWER = -10;
export declare const INTEGER_SMALL_EXCLUSIVE_BOUND_UPPER = 10;
export declare const INTEGER_SMALL_TOKEN_EXCLUSIVE_BOUND_LOWER = 191;
export declare const INTEGER_SMALL_TOKEN_EXCLUSIVE_BOUND_UPPER = 211;
export declare const INTEGER_SMALL_TOKEN_OFFSET = -201;
export declare const INTEGER_SMALL_TOKEN_ELEMENT_OFFSET = 9;
export declare const INTEGER_SMALL_TOKENS: string[];
